#ifndef _DECL_WSLB_H_
#define _DECL_WSLB_H_
#include "charm++.h"
#include "envelope.h"
#include <memory>
#include "sdag.h"
#include "LBDatabase.decl.h"

#include "BaseLB.decl.h"

/* DECLS: message WSLBStatsMsg;
 */
class WSLBStatsMsg;
class CMessage_WSLBStatsMsg:public CkMessage{
  public:
    static int __idx;
    void* operator new(size_t, void*p) { return p; }
    void* operator new(size_t);
    void* operator new(size_t, int*, const int);
    void* operator new(size_t, int*);
#if CMK_MULTIPLE_DELETE
    void operator delete(void*p, void*){dealloc(p);}
    void operator delete(void*p){dealloc(p);}
    void operator delete(void*p, int*, const int){dealloc(p);}
    void operator delete(void*p, int*){dealloc(p);}
#endif
    void operator delete(void*p, size_t){dealloc(p);}
    static void* alloc(int,size_t, int*, int);
    static void dealloc(void *p);
    CMessage_WSLBStatsMsg();
    static void *pack(WSLBStatsMsg *p);
    static WSLBStatsMsg* unpack(void* p);
    void *operator new(size_t, const int);
#if CMK_MULTIPLE_DELETE
    void operator delete(void *p, const int){dealloc(p);}
#endif
    static void __register(const char *s, size_t size, CkPackFnPtr pack, CkUnpackFnPtr unpack) {
      __idx = CkRegisterMsg(s, pack, unpack, dealloc, size);
    }
};


/* DECLS: group WSLB: BaseLB{
void WSLB(const CkLBOptions &impl_noname_0);
void ReceiveStats(WSLBStatsMsg* impl_msg);
void ResumeClients();
void ReceiveMigration(LBMigrateMsg* impl_msg);
WSLB(CkMigrateMessage* impl_msg);
};
 */
 class WSLB;
 class CkIndex_WSLB;
 class CProxy_WSLB;
 class CProxyElement_WSLB;
 class CProxySection_WSLB;
/* --------------- index object ------------------ */
class CkIndex_WSLB:public CkIndex_BaseLB{
  public:
    typedef WSLB local_t;
    typedef CkIndex_WSLB index_t;
    typedef CProxy_WSLB proxy_t;
    typedef CProxyElement_WSLB element_t;
    typedef CProxySection_WSLB section_t;

    static int __idx;
    static void __register(const char *s, size_t size);
    /* DECLS: void WSLB(const CkLBOptions &impl_noname_0);
     */
    // Entry point registration at startup
    
    static int reg_WSLB_marshall1();
    // Entry point index lookup
    
    inline static int idx_WSLB_marshall1() {
      static int epidx = reg_WSLB_marshall1();
      return epidx;
    }

    
    static int ckNew(const CkLBOptions &impl_noname_0) { return idx_WSLB_marshall1(); }
    
    static void _call_WSLB_marshall1(void* impl_msg, void* impl_obj);
    
    static void _call_sdag_WSLB_marshall1(void* impl_msg, void* impl_obj);
    
    static int _callmarshall_WSLB_marshall1(char* impl_buf, void* impl_obj_void);
    
    static void _marshallmessagepup_WSLB_marshall1(PUP::er &p,void *msg);
    /* DECLS: void ReceiveStats(WSLBStatsMsg* impl_msg);
     */
    // Entry point registration at startup
    
    static int reg_ReceiveStats_WSLBStatsMsg();
    // Entry point index lookup
    
    inline static int idx_ReceiveStats_WSLBStatsMsg() {
      static int epidx = reg_ReceiveStats_WSLBStatsMsg();
      return epidx;
    }

    
    inline static int idx_ReceiveStats(void (WSLB::*)(WSLBStatsMsg* impl_msg) ) {
      return idx_ReceiveStats_WSLBStatsMsg();
    }


    
    static int ReceiveStats(WSLBStatsMsg* impl_msg) { return idx_ReceiveStats_WSLBStatsMsg(); }
    
    static void _call_ReceiveStats_WSLBStatsMsg(void* impl_msg, void* impl_obj);
    
    static void _call_sdag_ReceiveStats_WSLBStatsMsg(void* impl_msg, void* impl_obj);
    /* DECLS: void ResumeClients();
     */
    // Entry point registration at startup
    
    static int reg_ResumeClients_void();
    // Entry point index lookup
    
    inline static int idx_ResumeClients_void() {
      static int epidx = reg_ResumeClients_void();
      return epidx;
    }

    
    inline static int idx_ResumeClients(void (WSLB::*)() ) {
      return idx_ResumeClients_void();
    }


    
    static int ResumeClients() { return idx_ResumeClients_void(); }
    
    static void _call_ResumeClients_void(void* impl_msg, void* impl_obj);
    
    static void _call_sdag_ResumeClients_void(void* impl_msg, void* impl_obj);
    /* DECLS: void ReceiveMigration(LBMigrateMsg* impl_msg);
     */
    // Entry point registration at startup
    
    static int reg_ReceiveMigration_LBMigrateMsg();
    // Entry point index lookup
    
    inline static int idx_ReceiveMigration_LBMigrateMsg() {
      static int epidx = reg_ReceiveMigration_LBMigrateMsg();
      return epidx;
    }

    
    inline static int idx_ReceiveMigration(void (WSLB::*)(LBMigrateMsg* impl_msg) ) {
      return idx_ReceiveMigration_LBMigrateMsg();
    }


    
    static int ReceiveMigration(LBMigrateMsg* impl_msg) { return idx_ReceiveMigration_LBMigrateMsg(); }
    
    static void _call_ReceiveMigration_LBMigrateMsg(void* impl_msg, void* impl_obj);
    
    static void _call_sdag_ReceiveMigration_LBMigrateMsg(void* impl_msg, void* impl_obj);
    /* DECLS: WSLB(CkMigrateMessage* impl_msg);
     */
    // Entry point registration at startup
    
    static int reg_WSLB_CkMigrateMessage();
    // Entry point index lookup
    
    inline static int idx_WSLB_CkMigrateMessage() {
      static int epidx = reg_WSLB_CkMigrateMessage();
      return epidx;
    }

    
    static int ckNew(CkMigrateMessage* impl_msg) { return idx_WSLB_CkMigrateMessage(); }
    
    static void _call_WSLB_CkMigrateMessage(void* impl_msg, void* impl_obj);
    
    static void _call_sdag_WSLB_CkMigrateMessage(void* impl_msg, void* impl_obj);
};
/* --------------- element proxy ------------------ */
class CProxyElement_WSLB: public CProxyElement_BaseLB{
  public:
    typedef WSLB local_t;
    typedef CkIndex_WSLB index_t;
    typedef CProxy_WSLB proxy_t;
    typedef CProxyElement_WSLB element_t;
    typedef CProxySection_WSLB section_t;


    /* TRAM aggregators */

    CProxyElement_WSLB(void) {
    }
    CProxyElement_WSLB(const IrrGroup *g) : CProxyElement_BaseLB(g){
    }
    CProxyElement_WSLB(CkGroupID _gid,int _onPE,CK_DELCTOR_PARAM) : CProxyElement_BaseLB(_gid,_onPE,CK_DELCTOR_ARGS){
    }
    CProxyElement_WSLB(CkGroupID _gid,int _onPE) : CProxyElement_BaseLB(_gid,_onPE){
    }

    int ckIsDelegated(void) const
    { return CProxyElement_BaseLB::ckIsDelegated(); }
    inline CkDelegateMgr *ckDelegatedTo(void) const
    { return CProxyElement_BaseLB::ckDelegatedTo(); }
    inline CkDelegateData *ckDelegatedPtr(void) const
    { return CProxyElement_BaseLB::ckDelegatedPtr(); }
    CkGroupID ckDelegatedIdx(void) const
    { return CProxyElement_BaseLB::ckDelegatedIdx(); }
inline void ckCheck(void) const {CProxyElement_BaseLB::ckCheck();}
CkChareID ckGetChareID(void) const
   {return CProxyElement_BaseLB::ckGetChareID();}
CkGroupID ckGetGroupID(void) const
   {return CProxyElement_BaseLB::ckGetGroupID();}
operator CkGroupID () const { return ckGetGroupID(); }

    inline void setReductionClient(CkReductionClientFn fn,void *param=NULL) const
    { CProxyElement_BaseLB::setReductionClient(fn,param); }
    inline void ckSetReductionClient(CkReductionClientFn fn,void *param=NULL) const
    { CProxyElement_BaseLB::ckSetReductionClient(fn,param); }
    inline void ckSetReductionClient(CkCallback *cb) const
    { CProxyElement_BaseLB::ckSetReductionClient(cb); }
int ckGetGroupPe(void) const
{return CProxyElement_BaseLB::ckGetGroupPe();}

    void ckDelegate(CkDelegateMgr *dTo,CkDelegateData *dPtr=NULL)
    {       CProxyElement_BaseLB::ckDelegate(dTo,dPtr); }
    void ckUndelegate(void)
    {       CProxyElement_BaseLB::ckUndelegate(); }
    void pup(PUP::er &p)
    {       CProxyElement_BaseLB::pup(p);
    }
    void ckSetGroupID(CkGroupID g) {
      CProxyElement_BaseLB::ckSetGroupID(g);
    }
    WSLB* ckLocalBranch(void) const {
      return ckLocalBranch(ckGetGroupID());
    }
    static WSLB* ckLocalBranch(CkGroupID gID) {
      return (WSLB*)CkLocalBranch(gID);
    }
/* DECLS: void WSLB(const CkLBOptions &impl_noname_0);
 */
    

/* DECLS: void ReceiveStats(WSLBStatsMsg* impl_msg);
 */
    
    void ReceiveStats(WSLBStatsMsg* impl_msg);

/* DECLS: void ResumeClients();
 */
    
    void ResumeClients(const CkEntryOptions *impl_e_opts=NULL);

/* DECLS: void ReceiveMigration(LBMigrateMsg* impl_msg);
 */
    
    void ReceiveMigration(LBMigrateMsg* impl_msg);

/* DECLS: WSLB(CkMigrateMessage* impl_msg);
 */

};
PUPmarshall(CProxyElement_WSLB)
/* ---------------- collective proxy -------------- */
class CProxy_WSLB: public CProxy_BaseLB{
  public:
    typedef WSLB local_t;
    typedef CkIndex_WSLB index_t;
    typedef CProxy_WSLB proxy_t;
    typedef CProxyElement_WSLB element_t;
    typedef CProxySection_WSLB section_t;

    CProxy_WSLB(void) {
    }
    CProxy_WSLB(const IrrGroup *g) : CProxy_BaseLB(g){
    }
    CProxy_WSLB(CkGroupID _gid,CK_DELCTOR_PARAM) : CProxy_BaseLB(_gid,CK_DELCTOR_ARGS){  }
    CProxy_WSLB(CkGroupID _gid) : CProxy_BaseLB(_gid){  }
    CProxyElement_WSLB operator[](int onPE) const
      {return CProxyElement_WSLB(ckGetGroupID(),onPE,CK_DELCTOR_CALL);}

    int ckIsDelegated(void) const
    { return CProxy_BaseLB::ckIsDelegated(); }
    inline CkDelegateMgr *ckDelegatedTo(void) const
    { return CProxy_BaseLB::ckDelegatedTo(); }
    inline CkDelegateData *ckDelegatedPtr(void) const
    { return CProxy_BaseLB::ckDelegatedPtr(); }
    CkGroupID ckDelegatedIdx(void) const
    { return CProxy_BaseLB::ckDelegatedIdx(); }
inline void ckCheck(void) const {CProxy_BaseLB::ckCheck();}
CkChareID ckGetChareID(void) const
   {return CProxy_BaseLB::ckGetChareID();}
CkGroupID ckGetGroupID(void) const
   {return CProxy_BaseLB::ckGetGroupID();}
operator CkGroupID () const { return ckGetGroupID(); }

    inline void setReductionClient(CkReductionClientFn fn,void *param=NULL) const
    { CProxy_BaseLB::setReductionClient(fn,param); }
    inline void ckSetReductionClient(CkReductionClientFn fn,void *param=NULL) const
    { CProxy_BaseLB::ckSetReductionClient(fn,param); }
    inline void ckSetReductionClient(CkCallback *cb) const
    { CProxy_BaseLB::ckSetReductionClient(cb); }

    void ckDelegate(CkDelegateMgr *dTo,CkDelegateData *dPtr=NULL)
    {       CProxy_BaseLB::ckDelegate(dTo,dPtr); }
    void ckUndelegate(void)
    {       CProxy_BaseLB::ckUndelegate(); }
    void pup(PUP::er &p)
    {       CProxy_BaseLB::pup(p);
    }
    void ckSetGroupID(CkGroupID g) {
      CProxy_BaseLB::ckSetGroupID(g);
    }
    WSLB* ckLocalBranch(void) const {
      return ckLocalBranch(ckGetGroupID());
    }
    static WSLB* ckLocalBranch(CkGroupID gID) {
      return (WSLB*)CkLocalBranch(gID);
    }
/* DECLS: void WSLB(const CkLBOptions &impl_noname_0);
 */
    
    static CkGroupID ckNew(const CkLBOptions &impl_noname_0, const CkEntryOptions *impl_e_opts=NULL);
    CProxy_WSLB(const CkLBOptions &impl_noname_0, const CkEntryOptions *impl_e_opts=NULL);

/* DECLS: void ReceiveStats(WSLBStatsMsg* impl_msg);
 */
    
    void ReceiveStats(WSLBStatsMsg* impl_msg);
    
    void ReceiveStats(WSLBStatsMsg* impl_msg, int npes, int *pes);
    
    void ReceiveStats(WSLBStatsMsg* impl_msg, CmiGroup &grp);

/* DECLS: void ResumeClients();
 */
    
    void ResumeClients(const CkEntryOptions *impl_e_opts=NULL);
    
    void ResumeClients(int npes, int *pes, const CkEntryOptions *impl_e_opts=NULL);
    
    void ResumeClients(CmiGroup &grp, const CkEntryOptions *impl_e_opts=NULL);

/* DECLS: void ReceiveMigration(LBMigrateMsg* impl_msg);
 */
    
    void ReceiveMigration(LBMigrateMsg* impl_msg);
    
    void ReceiveMigration(LBMigrateMsg* impl_msg, int npes, int *pes);
    
    void ReceiveMigration(LBMigrateMsg* impl_msg, CmiGroup &grp);

/* DECLS: WSLB(CkMigrateMessage* impl_msg);
 */

};
PUPmarshall(CProxy_WSLB)
/* ---------------- section proxy -------------- */
class CProxySection_WSLB: public CProxySection_BaseLB{
  public:
    typedef WSLB local_t;
    typedef CkIndex_WSLB index_t;
    typedef CProxy_WSLB proxy_t;
    typedef CProxyElement_WSLB element_t;
    typedef CProxySection_WSLB section_t;

    CProxySection_WSLB(void) {
    }
    CProxySection_WSLB(const IrrGroup *g) : CProxySection_BaseLB(g){
    }
    CProxySection_WSLB(const CkGroupID &_gid,const int *_pelist,int _npes, CK_DELCTOR_PARAM) : CProxySection_BaseLB(_gid,_pelist,_npes,CK_DELCTOR_ARGS){  }
    CProxySection_WSLB(const CkGroupID &_gid,const int *_pelist,int _npes, int factor = USE_DEFAULT_BRANCH_FACTOR) : CProxySection_BaseLB(_gid,_pelist,_npes,factor){  }
    CProxySection_WSLB(int n,const CkGroupID *_gid, int const * const *_pelist,const int *_npes, int factor = USE_DEFAULT_BRANCH_FACTOR) : CProxySection_BaseLB(n,_gid,_pelist,_npes,factor){  }
    CProxySection_WSLB(int n,const CkGroupID *_gid, int const * const *_pelist,const int *_npes, CK_DELCTOR_PARAM) : CProxySection_BaseLB(n,_gid,_pelist,_npes,CK_DELCTOR_ARGS){  }

    int ckIsDelegated(void) const
    { return CProxySection_BaseLB::ckIsDelegated(); }
    inline CkDelegateMgr *ckDelegatedTo(void) const
    { return CProxySection_BaseLB::ckDelegatedTo(); }
    inline CkDelegateData *ckDelegatedPtr(void) const
    { return CProxySection_BaseLB::ckDelegatedPtr(); }
    CkGroupID ckDelegatedIdx(void) const
    { return CProxySection_BaseLB::ckDelegatedIdx(); }
inline void ckCheck(void) const {CProxySection_BaseLB::ckCheck();}
CkChareID ckGetChareID(void) const
   {return CProxySection_BaseLB::ckGetChareID();}
CkGroupID ckGetGroupID(void) const
   {return CProxySection_BaseLB::ckGetGroupID();}
operator CkGroupID () const { return ckGetGroupID(); }

    inline void setReductionClient(CkReductionClientFn fn,void *param=NULL) const
    { CProxySection_BaseLB::setReductionClient(fn,param); }
    inline void ckSetReductionClient(CkReductionClientFn fn,void *param=NULL) const
    { CProxySection_BaseLB::ckSetReductionClient(fn,param); }
    inline void ckSetReductionClient(CkCallback *cb) const
    { CProxySection_BaseLB::ckSetReductionClient(cb); }
inline int ckGetNumSections() const
{ return CProxySection_BaseLB::ckGetNumSections(); }
inline CkSectionInfo &ckGetSectionInfo()
{ return CProxySection_BaseLB::ckGetSectionInfo(); }
inline CkSectionID *ckGetSectionIDs()
{ return CProxySection_BaseLB::ckGetSectionIDs(); }
inline CkSectionID &ckGetSectionID()
{ return CProxySection_BaseLB::ckGetSectionID(); }
inline CkSectionID &ckGetSectionID(int i)
{ return CProxySection_BaseLB::ckGetSectionID(i); }
inline CkGroupID ckGetGroupIDn(int i) const
{ return CProxySection_BaseLB::ckGetGroupIDn(i); }
inline int *ckGetElements() const
{ return CProxySection_BaseLB::ckGetElements(); }
inline int *ckGetElements(int i) const
{ return CProxySection_BaseLB::ckGetElements(i); }
inline int ckGetNumElements() const
{ return CProxySection_BaseLB::ckGetNumElements(); } 
inline int ckGetNumElements(int i) const
{ return CProxySection_BaseLB::ckGetNumElements(i); }

    void ckDelegate(CkDelegateMgr *dTo,CkDelegateData *dPtr=NULL)
    {       CProxySection_BaseLB::ckDelegate(dTo,dPtr); }
    void ckUndelegate(void)
    {       CProxySection_BaseLB::ckUndelegate(); }
    void pup(PUP::er &p)
    {       CProxySection_BaseLB::pup(p);
    }
    void ckSetGroupID(CkGroupID g) {
      CProxySection_BaseLB::ckSetGroupID(g);
    }
    WSLB* ckLocalBranch(void) const {
      return ckLocalBranch(ckGetGroupID());
    }
    static WSLB* ckLocalBranch(CkGroupID gID) {
      return (WSLB*)CkLocalBranch(gID);
    }
/* DECLS: void WSLB(const CkLBOptions &impl_noname_0);
 */
    

/* DECLS: void ReceiveStats(WSLBStatsMsg* impl_msg);
 */
    
    void ReceiveStats(WSLBStatsMsg* impl_msg);

/* DECLS: void ResumeClients();
 */
    
    void ResumeClients(const CkEntryOptions *impl_e_opts=NULL);

/* DECLS: void ReceiveMigration(LBMigrateMsg* impl_msg);
 */
    
    void ReceiveMigration(LBMigrateMsg* impl_msg);

/* DECLS: WSLB(CkMigrateMessage* impl_msg);
 */

};
PUPmarshall(CProxySection_WSLB)
#define WSLB_SDAG_CODE 
typedef CBaseT1<BaseLB, CProxy_WSLB>CBase_WSLB;





/* ---------------- method closures -------------- */
class Closure_WSLB {
  public:



    struct ResumeClients_3_closure;



};

extern void _registerWSLB(void);
#endif
